Package org.flowable.engine

# Class ProcessEngineConfiguration

java.lang.Object
org.flowable.common.engine.impl.AbstractEngineConfiguration
org.flowable.common.engine.impl.AbstractBuildableEngineConfiguration<ProcessEngine>
org.flowable.engine.ProcessEngineConfiguration

public abstract class ProcessEngineConfiguration extends org.flowable.common.engine.impl.AbstractBuildableEngineConfiguration<ProcessEngine>
Configuration information from which a process engine can be build.

Most common is to create a process engine based on the default configuration file:

     ProcessEngine processEngine = ProcessEngineConfiguration.createProcessEngineConfigurationFromResourceDefault().buildProcessEngine();

To create a process engine programmatic, without a configuration file, the first option is `createStandaloneProcessEngineConfiguration()`

     ProcessEngine processEngine = ProcessEngineConfiguration.createStandaloneProcessEngineConfiguration().buildProcessEngine();

This creates a new process engine with all the defaults to connect to a remote h2 database (jdbc:h2:tcp://localhost/flowable) in standalone mode. Standalone mode means that the process engine will manage the transactions on the JDBC connections that it creates. One transaction per service method. For a description of how to write the configuration files, see the userguide.

The second option is great for testing: `createStandaloneInMemProcessEngineConfiguration()`

     ProcessEngine processEngine = ProcessEngineConfiguration.createStandaloneInMemProcessEngineConfiguration().buildProcessEngine();

This creates a new process engine with all the defaults to connect to an memory h2 database (jdbc:h2:tcp://localhost/flowable) in standalone mode. The DB schema strategy default is in this case `create-drop`. Standalone mode means that Flowable will manage the transactions on the JDBC connections that it creates. One transaction per service method.

On all forms of creating a process engine, you can first customize the configuration before calling the `buildProcessEngine()` method by calling any of the setters like this:

     ProcessEngine processEngine = ProcessEngineConfiguration.createProcessEngineConfigurationFromResourceDefault().setMailServerHost("gmail.com").setJdbcUsername("mickey").setJdbcPassword("mouse")
             .buildProcessEngine();

Author:
  Tom Baeyens
See Also:
  - `ProcessEngines`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected String`
  `activityFontName`
  `protected boolean`
  `alwaysUseArraysForDmnMultiHitPolicies`
  `protected String`
  `annotationFontName`
  `protected org.flowable.job.service.impl.asyncexecutor.AsyncExecutor`
  `asyncExecutor`
  `protected boolean`
  `asyncExecutorActivate`
  `protected int`
  `asyncFailedJobWaitTime`
  define the default wait time for a failed async job in seconds
  `protected org.flowable.job.service.impl.asyncexecutor.AsyncExecutor`
  `asyncHistoryExecutor`
  `protected boolean`
  `asyncHistoryExecutorActivate`
  `protected AsyncTaskExecutor`
  `asyncHistoryTaskExecutor`
  `protected AsyncTaskExecutor`
  `asyncTaskExecutor`
  `protected AsyncTaskInvoker`
  `asyncTaskInvoker`
  `protected AsyncTaskExecutor`
  `asyncTaskInvokerTaskExecutor`
  `protected int`
  `cleanInstancesBatchSize`
  `protected Duration`
  `cleanInstancesEndedAfter`
  `protected String`
  `defaultCamelContext`
  `protected int`
  `defaultFailedJobWaitTime`
  define the default wait time for a failed job in seconds
  `protected org.flowable.mail.common.api.client.FlowableMailClient`
  `defaultMailClient`
  `protected org.flowable.common.engine.impl.cfg.mail.MailServerInfo`
  `defaultMailServer`
  `protected boolean`
  `drawSequenceFlowNameWithNoLabelDI`
  include the sequence flow name in case there's no Label DI,
  `protected boolean`
  `enableHistoryCleaning`
  `protected boolean`
  `enableProcessDefinitionHistoryLevel`
  `protected boolean`
  `enableProcessDefinitionInfoCache`
  `protected String`
  `history`
  `protected HistoryCleaningManager`
  `historyCleaningManager`
  `protected String`
  `historyCleaningTimeCycleConfig`
  `protected org.flowable.common.engine.impl.history.HistoryLevel`
  `historyLevel`
  `protected HttpClientConfig`
  `httpClientConfig`
  `protected int`
  `idBlockSize`
  `protected boolean`
  `isCreateDiagramOnDeploy`
  `protected boolean`
  `jpaCloseEntityManager`
  `protected Object`
  `jpaEntityManagerFactory`
  `protected boolean`
  `jpaHandleTransaction`
  `protected String`
  `jpaPersistenceUnitName`
  `protected String`
  `labelFontName`
  `protected Map<String,org.flowable.mail.common.api.client.FlowableMailClient>`
  `mailClients`
  `protected Map<String,org.flowable.common.engine.impl.cfg.mail.MailServerInfo>`
  `mailServers`
  `protected String`
  `mailSessionJndi`
  `protected Map<String,String>`
  `mailSessionsJndi`
  `protected org.flowable.image.ProcessDiagramGenerator`
  `processDiagramGenerator`
  Process diagram generator.
  `protected String`
  `processEngineName`
  `protected boolean`
  `shutdownAsyncHistoryTaskExecutor`
  `protected boolean`
  `shutdownAsyncTaskExecutor`
  `protected boolean`
  `shutdownAsyncTaskInvokerTaskExecutor`
  `protected org.flowable.task.service.TaskPostProcessor`
  `taskPostProcessor`
  postprocessor for a task builder

  ### Fields inherited from class org.flowable.common.engine.impl.AbstractBuildableEngineConfiguration

  `postEngineBuildConsumer, runPostEngineBuildConsumer`

  ### Fields inherited from class org.flowable.common.engine.impl.AbstractEngineConfiguration

  `additionalEventDispatchActions, additionalSchemaManagers, agendaOperationExecutionListeners, agendaOperationRunner, allConfigurators, alwaysLookupLatestDefinitionVersion, beans, byteArrayDataManager, byteArrayEntityManager, classLoader, clock, commandContextFactory, commandExecutor, commandInterceptors, commandInvoker, commonSchemaManager, configurators, customMybatisInterceptors, customMybatisMappers, customMybatisXMLMappers, customPostCommandInterceptors, customPostDeployers, customPreCommandInterceptors, customPreDeployers, customSessionFactories, DATABASE_TYPE_COCKROACHDB, DATABASE_TYPE_DB2, DATABASE_TYPE_H2, DATABASE_TYPE_HSQL, DATABASE_TYPE_MSSQL, DATABASE_TYPE_MYSQL, DATABASE_TYPE_ORACLE, DATABASE_TYPE_POSTGRES, databaseCatalog, databaseSchema, databaseSchemaUpdate, databaseTablePrefix, databaseType, databaseTypeMappings, databaseWildcardEscapeCharacter, dataSource, dataSourceJndiName, DB_SCHEMA_UPDATE_CREATE, DB_SCHEMA_UPDATE_CREATE_DROP, DB_SCHEMA_UPDATE_DROP_CREATE, DB_SCHEMA_UPDATE_FALSE, DB_SCHEMA_UPDATE_TRUE, dbSqlSessionFactory, DEFAULT_GENERIC_MAX_LENGTH_STRING, DEFAULT_MAX_NR_OF_STATEMENTS_BULK_INSERT_SQL_SERVER, DEFAULT_ORACLE_MAX_LENGTH_STRING, defaultCommandConfig, defaultCommandInterceptors, defaultTenantProvider, dependentEngineMybatisTypeAliasConfigs, dependentEngineMybatisTypeHandlerConfigs, dependentEngineMyBatisXmlMappers, deployers, enableConfiguratorServiceLoader, enableEventDispatcher, enableLogSqlExecutionTime, engineConfigurations, engineLifecycleListeners, eventDispatcher, eventListeners, eventRegistryConfigurator, eventRegistryEventConsumers, fallbackToDefaultTenant, forceCloseMybatisConnectionPool, idGenerator, idmEngineConfigurator, isBulkInsertEnabled, isDbHistoryUsed, jdbcDefaultTransactionIsolationLevel, jdbcDriver, jdbcMaxActiveConnections, jdbcMaxCheckoutTime, jdbcMaxIdleConnections, jdbcMaxWaitTime, jdbcPassword, jdbcPingConnectionNotUsedFor, jdbcPingEnabled, jdbcPingQuery, jdbcUrl, jdbcUsername, lockPollRate, logger, loggingListener, maxLengthStringVariableType, maxNrOfStatementsInBulkInsert, mybatisMappingFile, NO_TENANT_ID, objectMapper, PRODUCT_NAME_CRDB, PRODUCT_NAME_POSTGRES, propertyDataManager, propertyEntityManager, schemaCommandConfig, schemaLockWaitTime, schemaManagementCmd, schemaManager, serviceConfigurations, sessionFactories, sqlSessionFactory, tableDataManager, tablePrefixIsSchema, transactionContextFactory, transactionFactory, transactionsExternallyManaged, typedEventListeners, useClassForNameClassLoading, useLockForDatabaseSchemaUpdate, usePrefixId, usingRelationalDatabase, usingSchemaMgmt, variableLengthVerifier, xmlEncoding`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ProcessEngineConfiguration()`
  use one of the static createXxxx methods instead

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ProcessEngine`
  `buildProcessEngine()`
  `static ProcessEngineConfiguration`
  `createProcessEngineConfigurationFromInputStream(InputStream inputStream)`
  `static ProcessEngineConfiguration`
  `createProcessEngineConfigurationFromInputStream(InputStream inputStream, String beanName)`
  `static ProcessEngineConfiguration`
  `createProcessEngineConfigurationFromResource(String resource)`
  `static ProcessEngineConfiguration`
  `createProcessEngineConfigurationFromResource(String resource, String beanName)`
  `static ProcessEngineConfiguration`
  `createProcessEngineConfigurationFromResourceDefault()`
  `static ProcessEngineConfiguration`
  `createStandaloneInMemProcessEngineConfiguration()`
  `static ProcessEngineConfiguration`
  `createStandaloneProcessEngineConfiguration()`
  `String`
  `getActivityFontName()`
  `String`
  `getAnnotationFontName()`
  `org.flowable.job.service.impl.asyncexecutor.AsyncExecutor`
  `getAsyncExecutor()`
  `int`
  `getAsyncFailedJobWaitTime()`
  `org.flowable.job.service.impl.asyncexecutor.AsyncExecutor`
  `getAsyncHistoryExecutor()`
  `AsyncTaskExecutor`
  `getAsyncHistoryTaskExecutor()`
  `AsyncTaskExecutor`
  `getAsyncTaskExecutor()`
  `AsyncTaskInvoker`
  `getAsyncTaskInvoker()`
  `AsyncTaskExecutor`
  `getAsyncTaskInvokerTaskExecutor()`
  `int`
  `getCleanInstancesBatchSize()`
  `Duration`
  `getCleanInstancesEndedAfter()`
  `int`
  `getCleanInstancesEndedAfterNumberOfDays()`
  Deprecated.
  use `getCleanInstancesEndedAfter()` instead
  `String`
  `getDefaultCamelContext()`
  `int`
  `getDefaultFailedJobWaitTime()`
  `org.flowable.mail.common.api.client.FlowableMailClient`
  `getDefaultMailClient()`
  `org.flowable.common.engine.impl.cfg.mail.MailServerInfo`
  `getDefaultMailServer()`
  `String`
  `getEngineName()`
  `abstract FormService`
  `getFormService()`
  `String`
  `getHistory()`
  `HistoryCleaningManager`
  `getHistoryCleaningManager()`
  `String`
  `getHistoryCleaningTimeCycleConfig()`
  `org.flowable.common.engine.impl.history.HistoryLevel`
  `getHistoryLevel()`
  `abstract HistoryService`
  `getHistoryService()`
  `HttpClientConfig`
  `getHttpClientConfig()`
  `int`
  `getIdBlockSize()`
  `abstract IdentityService`
  `getIdentityService()`
  `Object`
  `getJpaEntityManagerFactory()`
  `String`
  `getJpaPersistenceUnitName()`
  `String`
  `getLabelFontName()`
  `org.flowable.mail.common.api.client.FlowableMailClient`
  `getMailClient(String tenantId)`
  `Map<String,org.flowable.mail.common.api.client.FlowableMailClient>`
  `getMailClients()`
  `org.flowable.common.engine.impl.cfg.mail.MailServerInfo`
  `getMailServer(String tenantId)`
  `Charset`
  `getMailServerDefaultCharset()`
  `String`
  `getMailServerDefaultFrom()`
  `String`
  `getMailServerForceTo()`
  `String`
  `getMailServerHost()`
  `String`
  `getMailServerPassword()`
  `int`
  `getMailServerPort()`
  `Map<String,org.flowable.common.engine.impl.cfg.mail.MailServerInfo>`
  `getMailServers()`
  `int`
  `getMailServerSSLPort()`
  `String`
  `getMailServerUsername()`
  `boolean`
  `getMailServerUseSSL()`
  `boolean`
  `getMailServerUseTLS()`
  `String`
  `getMailSessionJndi()`
  `String`
  `getMailSessionJndi(String tenantId)`
  `Map<String,String>`
  `getMailSessionsJndi()`
  `abstract ManagementService`
  `getManagementService()`
  `protected org.flowable.common.engine.impl.cfg.mail.MailServerInfo`
  `getOrCreateDefaultMaiLServer()`
  `org.flowable.image.ProcessDiagramGenerator`
  `getProcessDiagramGenerator()`
  `abstract ProcessEngineConfiguration`
  `getProcessEngineConfiguration()`
  `abstract RepositoryService`
  `getRepositoryService()`
  `abstract RuntimeService`
  `getRuntimeService()`
  `org.flowable.task.service.TaskPostProcessor`
  `getTaskPostProcessor()`
  `abstract TaskService`
  `getTaskService()`
  `boolean`
  `isAlwaysUseArraysForDmnMultiHitPolicies()`
  `boolean`
  `isAsyncExecutorActivate()`
  `boolean`
  `isAsyncHistoryExecutorActivate()`
  `boolean`
  `isCreateDiagramOnDeploy()`
  `boolean`
  `isDrawSequenceFlowNameWithNoLabelDI()`
  `boolean`
  `isEnableHistoryCleaning()`
  `boolean`
  `isEnableProcessDefinitionHistoryLevel()`
  `boolean`
  `isEnableProcessDefinitionInfoCache()`
  `boolean`
  `isJpaCloseEntityManager()`
  `boolean`
  `isJpaHandleTransaction()`
  `ProcessEngineConfiguration`
  `setActivityFontName(String activityFontName)`
  `ProcessEngineConfiguration`
  `setAlwaysUseArraysForDmnMultiHitPolicies(boolean alwaysUseArraysForDmnMultiHitPolicies)`
  `ProcessEngineConfiguration`
  `setAnnotationFontName(String annotationFontName)`
  `ProcessEngineConfiguration`
  `setAsyncExecutor(org.flowable.job.service.impl.asyncexecutor.AsyncExecutor asyncExecutor)`
  `ProcessEngineConfiguration`
  `setAsyncExecutorActivate(boolean asyncExecutorActivate)`
  `ProcessEngineConfiguration`
  `setAsyncFailedJobWaitTime(int asyncFailedJobWaitTime)`
  `ProcessEngineConfiguration`
  `setAsyncHistoryExecutor(org.flowable.job.service.impl.asyncexecutor.AsyncExecutor asyncHistoryExecutor)`
  `ProcessEngineConfiguration`
  `setAsyncHistoryExecutorActivate(boolean asyncHistoryExecutorActivate)`
  `ProcessEngineConfiguration`
  `setAsyncHistoryTaskExecutor(AsyncTaskExecutor asyncHistoryTaskExecutor)`
  `ProcessEngineConfiguration`
  `setAsyncTaskExecutor(AsyncTaskExecutor asyncTaskExecutor)`
  `ProcessEngineConfiguration`
  `setAsyncTaskInvoker(AsyncTaskInvoker asyncTaskInvoker)`
  `ProcessEngineConfiguration`
  `setAsyncTaskInvokerTaskExecutor(AsyncTaskExecutor asyncTaskInvokerTaskExecutor)`
  `ProcessEngineConfiguration`
  `setClassLoader(ClassLoader classLoader)`
  `ProcessEngineConfiguration`
  `setCleanInstancesBatchSize(int cleanInstancesBatchSize)`
  `ProcessEngineConfiguration`
  `setCleanInstancesEndedAfter(Duration cleanInstancesEndedAfter)`
  `ProcessEngineConfiguration`
  `setCleanInstancesEndedAfterNumberOfDays(int cleanInstancesEndedAfterNumberOfDays)`
  Deprecated.
  use `setCleanInstancesEndedAfter(Duration)` instead
  `ProcessEngineConfiguration`
  `setClock(org.flowable.common.engine.impl.runtime.Clock clock)`
  `ProcessEngineConfiguration`
  `setCreateDiagramOnDeploy(boolean createDiagramOnDeploy)`
  `ProcessEngineConfiguration`
  `setDatabaseCatalog(String databaseCatalog)`
  `ProcessEngineConfiguration`
  `setDatabaseSchema(String databaseSchema)`
  `ProcessEngineConfiguration`
  `setDatabaseSchemaUpdate(String databaseSchemaUpdate)`
  `ProcessEngineConfiguration`
  `setDatabaseTablePrefix(String databaseTablePrefix)`
  `ProcessEngineConfiguration`
  `setDatabaseType(String databaseType)`
  `ProcessEngineConfiguration`
  `setDatabaseWildcardEscapeCharacter(String databaseWildcardEscapeCharacter)`
  `ProcessEngineConfiguration`
  `setDataSource(DataSource dataSource)`
  `ProcessEngineConfiguration`
  `setDataSourceJndiName(String dataSourceJndiName)`
  `ProcessEngineConfiguration`
  `setDefaultCamelContext(String defaultCamelContext)`
  `ProcessEngineConfiguration`
  `setDefaultFailedJobWaitTime(int defaultFailedJobWaitTime)`
  `ProcessEngineConfiguration`
  `setDefaultMailClient(org.flowable.mail.common.api.client.FlowableMailClient defaultMailClient)`
  `ProcessEngineConfiguration`
  `setDefaultMailServer(org.flowable.common.engine.impl.cfg.mail.MailServerInfo defaultMailServer)`
  `ProcessEngineConfiguration`
  `setDrawSequenceFlowNameWithNoLabelDI(boolean drawSequenceFlowNameWithNoLabelDI)`
  `ProcessEngineConfiguration`
  `setEnableHistoryCleaning(boolean enableHistoryCleaning)`
  `ProcessEngineConfiguration`
  `setEnableProcessDefinitionHistoryLevel(boolean enableProcessDefinitionHistoryLevel)`
  `ProcessEngineConfiguration`
  `setEnableProcessDefinitionInfoCache(boolean enableProcessDefinitionInfoCache)`
  `ProcessEngineConfiguration`
  `setEngineName(String processEngineName)`
  `ProcessEngineConfiguration`
  `setHistory(String history)`
  `ProcessEngineConfiguration`
  `setHistoryCleaningManager(HistoryCleaningManager historyCleaningManager)`
  `ProcessEngineConfiguration`
  `setHistoryCleaningTimeCycleConfig(String historyCleaningTimeCycleConfig)`
  `ProcessEngineConfiguration`
  `setHistoryLevel(org.flowable.common.engine.impl.history.HistoryLevel historyLevel)`
  `void`
  `setHttpClientConfig(HttpClientConfig httpClientConfig)`
  `ProcessEngineConfiguration`
  `setIdBlockSize(int idBlockSize)`
  `ProcessEngineConfiguration`
  `setJdbcDefaultTransactionIsolationLevel(int jdbcDefaultTransactionIsolationLevel)`
  `ProcessEngineConfiguration`
  `setJdbcDriver(String jdbcDriver)`
  `ProcessEngineConfiguration`
  `setJdbcMaxActiveConnections(int jdbcMaxActiveConnections)`
  `ProcessEngineConfiguration`
  `setJdbcMaxCheckoutTime(int jdbcMaxCheckoutTime)`
  `ProcessEngineConfiguration`
  `setJdbcMaxIdleConnections(int jdbcMaxIdleConnections)`
  `ProcessEngineConfiguration`
  `setJdbcMaxWaitTime(int jdbcMaxWaitTime)`
  `ProcessEngineConfiguration`
  `setJdbcPassword(String jdbcPassword)`
  `ProcessEngineConfiguration`
  `setJdbcPingConnectionNotUsedFor(int jdbcPingNotUsedFor)`
  `ProcessEngineConfiguration`
  `setJdbcPingEnabled(boolean jdbcPingEnabled)`
  `ProcessEngineConfiguration`
  `setJdbcPingQuery(String jdbcPingQuery)`
  `ProcessEngineConfiguration`
  `setJdbcUrl(String jdbcUrl)`
  `ProcessEngineConfiguration`
  `setJdbcUsername(String jdbcUsername)`
  `ProcessEngineConfiguration`
  `setJpaCloseEntityManager(boolean jpaCloseEntityManager)`
  `ProcessEngineConfiguration`
  `setJpaEntityManagerFactory(Object jpaEntityManagerFactory)`
  `ProcessEngineConfiguration`
  `setJpaHandleTransaction(boolean jpaHandleTransaction)`
  `ProcessEngineConfiguration`
  `setJpaPersistenceUnitName(String jpaPersistenceUnitName)`
  `ProcessEngineConfiguration`
  `setLabelFontName(String labelFontName)`
  `ProcessEngineConfiguration`
  `setMailClients(Map<String,org.flowable.mail.common.api.client.FlowableMailClient> mailClients)`
  `ProcessEngineConfiguration`
  `setMailServerDefaultCharset(Charset mailServerDefaultCharset)`
  `ProcessEngineConfiguration`
  `setMailServerDefaultFrom(String mailServerDefaultFrom)`
  `ProcessEngineConfiguration`
  `setMailServerForceTo(String mailServerForceTo)`
  `ProcessEngineConfiguration`
  `setMailServerHost(String mailServerHost)`
  `ProcessEngineConfiguration`
  `setMailServerPassword(String mailServerPassword)`
  `ProcessEngineConfiguration`
  `setMailServerPort(int mailServerPort)`
  `ProcessEngineConfiguration`
  `setMailServers(Map<String,org.flowable.common.engine.impl.cfg.mail.MailServerInfo> mailServers)`
  `ProcessEngineConfiguration`
  `setMailServerSSLPort(int mailServerSSLPort)`
  `ProcessEngineConfiguration`
  `setMailServerUsername(String mailServerUsername)`
  `ProcessEngineConfiguration`
  `setMailServerUseSSL(boolean useSSL)`
  `ProcessEngineConfiguration`
  `setMailServerUseTLS(boolean useTLS)`
  `ProcessEngineConfiguration`
  `setMailSessionJndi(String mailSessionJndi)`
  `ProcessEngineConfiguration`
  `setMailSessionsJndi(Map<String,String> mailSessionsJndi)`
  `ProcessEngineConfiguration`
  `setProcessDiagramGenerator(org.flowable.image.ProcessDiagramGenerator processDiagramGenerator)`
  `ProcessEngineConfiguration`
  `setTablePrefixIsSchema(boolean tablePrefixIsSchema)`
  `void`
  `setTaskPostProcessor(org.flowable.task.service.TaskPostProcessor processor)`
  `ProcessEngineConfiguration`
  `setTransactionsExternallyManaged(boolean transactionsExternallyManaged)`
  `ProcessEngineConfiguration`
  `setUseClassForNameClassLoading(boolean useClassForNameClassLoading)`
  `ProcessEngineConfiguration`
  `setXmlEncoding(String xmlEncoding)`

  ### Methods inherited from class org.flowable.common.engine.impl.AbstractBuildableEngineConfiguration

  `buildEngine, createEngine, createPostEngineBuildConsumer, getPostEngineBuildConsumer, init, initPostEngineBuildConsumer, isRunPostEngineBuildConsumer, setPostEngineBuildConsumer, setRunPostEngineBuildConsumer`

  ### Methods inherited from class org.flowable.common.engine.impl.AbstractEngineConfiguration

  `addAdditionalSchemaManager, addAgendaOperationExecutionListener, addConfigurator, addCustomPostCommandInterceptor, addCustomPreCommandInterceptor, addCustomSessionFactory, addEngineConfiguration, addEngineLifecycleListener, addEventRegistryEventConsumer, addServiceConfiguration, addSessionFactory, applyCustomMybatisCustomizations, close, configuratorsAfterInit, configuratorsBeforeInit, createDbSqlSessionFactory, createEngineSchemaManager, createTransactionInterceptor, defaultInitDbSqlSessionFactoryEntitySettings, defaultInitDbSqlSessionFactoryEntitySettings, getAdditionalDefaultCommandInterceptors, getAdditionalEventDispatchActions, getAdditionalSchemaManagers, getAgendaOperationExecutionListeners, getAgendaOperationRunner, getAllConfigurators, getBeans, getByteArrayDataManager, getByteArrayEntityManager, getClassLoader, getClock, getCommandContextFactory, getCommandExecutor, getCommandInterceptors, getCommandInvoker, getCommonSchemaManager, getConfigurators, getCustomMybatisInterceptors, getCustomMybatisMappers, getCustomMybatisXMLMappers, getCustomPostCommandInterceptors, getCustomPostDeployers, getCustomPreCommandInterceptors, getCustomPreDeployers, getCustomSessionFactories, getDatabaseCatalog, getDatabaseSchema, getDatabaseSchemaUpdate, getDatabaseTablePrefix, getDatabaseType, getDatabaseWildcardEscapeCharacter, getDataSource, getDataSourceJndiName, getDbSqlSessionFactory, getDefaultCommandConfig, getDefaultCommandInterceptors, getDefaultDatabaseTypeMappings, getDefaultTenantProvider, getDependentEngineMybatisTypeAliasConfigs, getDependentEngineMybatisTypeHandlerConfigs, getDependentEngineMyBatisXmlMappers, getDeployers, getEngineCfgKey, getEngineConfigurations, getEngineLifecycleListeners, getEngineScopeType, getEngineSpecificEngineConfigurators, getEventDispatcher, getEventListeners, getEventRegistryConfigurator, getEventRegistryEventConsumers, getIdGenerator, getIdmEngineConfigurator, getJdbcDefaultTransactionIsolationLevel, getJdbcDriver, getJdbcMaxActiveConnections, getJdbcMaxCheckoutTime, getJdbcMaxIdleConnections, getJdbcMaxWaitTime, getJdbcPassword, getJdbcPingConnectionNotUsedFor, getJdbcPingQuery, getJdbcUrl, getJdbcUsername, getLockManager, getLockPollRate, getLoggingListener, getMaxLengthString, getMaxLengthStringVariableType, getMaxNrOfStatementsInBulkInsert, getMybatisMappingFile, getMyBatisXmlConfigurationStream, getObjectMapper, getPropertyDataManager, getPropertyEntityManager, getResourceAsStream, getSchemaCommandConfig, getSchemaLockWaitTime, getSchemaManagementCmd, getSchemaManager, getServiceConfigurations, getSessionFactories, getSqlSessionFactory, getTableDataManager, getTransactionContextFactory, getTransactionFactory, getTypedEventListeners, getVariableLengthVerifier, getXmlEncoding, initAdditionalEventDispatchActions, initBeans, initClock, initCommandContextFactory, initCommandExecutor, initCommandExecutors, initCommandInterceptors, initCommandInvoker, initConfigurators, initCustomMybatisInterceptors, initCustomMybatisMappers, initDatabaseType, initDataManagers, initDataSource, initDbSqlSessionFactory, initDbSqlSessionFactoryEntitySettings, initDefaultCommandConfig, initEngineConfigurations, initEntityManagers, initEventDispatcher, initEventListeners, initIdGenerator, initInterceptorChain, initMybatisConfiguration, initMyBatisLogSqlExecutionTimePlugin, initMybatisTypeHandlers, initObjectMapper, initSchemaCommandConfig, initSchemaManagementCommand, initSchemaManager, initSchemaManagerDatabaseConfigurationSessionFactory, initService, initSessionFactories, initSqlSessionFactory, initTransactionContextFactory, initTransactionFactory, initTypedEventListeners, isAlwaysLookupLatestDefinitionVersion, isBulkInsertEnabled, isDbHistoryUsed, isEnableConfiguratorServiceLoader, isEnableEventDispatcher, isEnableLogSqlExecutionTime, isFallbackToDefaultTenant, isForceCloseMybatisConnectionPool, isJdbcPingEnabled, isLoggingSessionEnabled, isTablePrefixIsSchema, isTransactionsExternallyManaged, isUseClassForNameClassLoading, isUseLockForDatabaseSchemaUpdate, isUsePrefixId, isUsingRelationalDatabase, isUsingSchemaMgmt, parseCustomMybatisXMLMappers, parseDependentEngineMybatisXMLMappers, parseMybatisConfiguration, parseMybatisXmlMapping, pathToEngineDbProperties, setAdditionalEventDispatchActions, setAgendaOperationExecutionListeners, setAgendaOperationRunner, setAlwaysLookupLatestDefinitionVersion, setBeans, setBulkInsertEnabled, setByteArrayDataManager, setByteArrayEntityManager, setCommandContextFactory, setCommandExecutor, setCommandInterceptors, setCommandInvoker, setCommonSchemaManager, setConfigurators, setCustomMybatisInterceptors, setCustomMybatisMappers, setCustomMybatisXMLMappers, setCustomPostCommandInterceptors, setCustomPostDeployers, setCustomPreCommandInterceptors, setCustomPreDeployers, setCustomSessionFactories, setDbHistoryUsed, setDbSqlSessionFactory, setDefaultCommandConfig, setDefaultCommandInterceptors, setDefaultTenantProvider, setDefaultTenantValue, setDependentEngineMybatisTypeAliasConfigs, setDependentEngineMybatisTypeHandlerConfigs, setDependentEngineMyBatisXmlMappers, setDeployers, setEnableConfiguratorServiceLoader, setEnableEventDispatcher, setEnableLogSqlExecutionTime, setEngineConfigurations, setEngineLifecycleListeners, setEventDispatcher, setEventListeners, setEventRegistryConfigurator, setEventRegistryEventConsumers, setFallbackToDefaultTenant, setForceCloseMybatisConnectionPool, setIdGenerator, setIdmEngineConfigurator, setLockPollRate, setLoggingListener, setMaxLengthStringVariableType, setMaxNrOfStatementsInBulkInsert, setMybatisMappingFile, setObjectMapper, setPropertyDataManager, setPropertyEntityManager, setSchemaCommandConfig, setSchemaLockWaitTime, setSchemaManagementCmd, setSchemaManager, setServiceConfigurations, setSessionFactories, setSqlSessionFactory, setTableDataManager, setTransactionContextFactory, setTransactionFactory, setTypedEventListeners, setUseLockForDatabaseSchemaUpdate, setUsePrefixId, setUsingRelationalDatabase, setUsingSchemaMgmt, setVariableLengthVerifier`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### processEngineName

    protected String processEngineName

  - ### idBlockSize

    protected int idBlockSize

  - ### history

    protected String history

  - ### asyncExecutorActivate

    protected boolean asyncExecutorActivate

  - ### asyncHistoryExecutorActivate

    protected boolean asyncHistoryExecutorActivate

  - ### defaultMailClient

    protected org.flowable.mail.common.api.client.FlowableMailClient defaultMailClient

  - ### defaultMailServer

    protected org.flowable.common.engine.impl.cfg.mail.MailServerInfo defaultMailServer

  - ### mailSessionJndi

    protected String mailSessionJndi

  - ### mailServers

    protected Map<String,org.flowable.common.engine.impl.cfg.mail.MailServerInfo> mailServers

  - ### mailClients

    protected Map<String,org.flowable.mail.common.api.client.FlowableMailClient> mailClients

  - ### mailSessionsJndi

    protected Map<String,String> mailSessionsJndi

  - ### httpClientConfig

    protected HttpClientConfig httpClientConfig

  - ### historyLevel

    protected org.flowable.common.engine.impl.history.HistoryLevel historyLevel

  - ### enableProcessDefinitionHistoryLevel

    protected boolean enableProcessDefinitionHistoryLevel

  - ### jpaPersistenceUnitName

    protected String jpaPersistenceUnitName

  - ### jpaEntityManagerFactory

    protected Object jpaEntityManagerFactory

  - ### jpaHandleTransaction

    protected boolean jpaHandleTransaction

  - ### jpaCloseEntityManager

    protected boolean jpaCloseEntityManager

  - ### asyncExecutor

    protected org.flowable.job.service.impl.asyncexecutor.AsyncExecutor asyncExecutor

  - ### asyncTaskExecutor

    protected AsyncTaskExecutor asyncTaskExecutor

  - ### shutdownAsyncTaskExecutor

    protected boolean shutdownAsyncTaskExecutor

  - ### asyncTaskInvokerTaskExecutor

    protected AsyncTaskExecutor asyncTaskInvokerTaskExecutor

  - ### shutdownAsyncTaskInvokerTaskExecutor

    protected boolean shutdownAsyncTaskInvokerTaskExecutor

  - ### asyncTaskInvoker

    protected AsyncTaskInvoker asyncTaskInvoker

  - ### asyncHistoryExecutor

    protected org.flowable.job.service.impl.asyncexecutor.AsyncExecutor asyncHistoryExecutor

  - ### asyncHistoryTaskExecutor

    protected AsyncTaskExecutor asyncHistoryTaskExecutor

  - ### shutdownAsyncHistoryTaskExecutor

    protected boolean shutdownAsyncHistoryTaskExecutor

  - ### defaultFailedJobWaitTime

    protected int defaultFailedJobWaitTime
    define the default wait time for a failed job in seconds

  - ### asyncFailedJobWaitTime

    protected int asyncFailedJobWaitTime
    define the default wait time for a failed async job in seconds

  - ### processDiagramGenerator

    protected org.flowable.image.ProcessDiagramGenerator processDiagramGenerator
    Process diagram generator. Default value is DefaultProcessDiagramGenerator

  - ### isCreateDiagramOnDeploy

    protected boolean isCreateDiagramOnDeploy

  - ### alwaysUseArraysForDmnMultiHitPolicies

    protected boolean alwaysUseArraysForDmnMultiHitPolicies

  - ### drawSequenceFlowNameWithNoLabelDI

    protected boolean drawSequenceFlowNameWithNoLabelDI
    include the sequence flow name in case there's no Label DI,

  - ### defaultCamelContext

    protected String defaultCamelContext

  - ### activityFontName

    protected String activityFontName

  - ### labelFontName

    protected String labelFontName

  - ### annotationFontName

    protected String annotationFontName

  - ### enableProcessDefinitionInfoCache

    protected boolean enableProcessDefinitionInfoCache

  - ### enableHistoryCleaning

    protected boolean enableHistoryCleaning

  - ### historyCleaningTimeCycleConfig

    protected String historyCleaningTimeCycleConfig

  - ### cleanInstancesEndedAfter

    protected Duration cleanInstancesEndedAfter

  - ### cleanInstancesBatchSize

    protected int cleanInstancesBatchSize

  - ### historyCleaningManager

    protected HistoryCleaningManager historyCleaningManager

  - ### taskPostProcessor

    protected org.flowable.task.service.TaskPostProcessor taskPostProcessor
    postprocessor for a task builder

- ## Constructor Details

  - ### ProcessEngineConfiguration

    protected ProcessEngineConfiguration()
    use one of the static createXxxx methods instead

- ## Method Details

  - ### buildProcessEngine

    public ProcessEngine buildProcessEngine()

  - ### createProcessEngineConfigurationFromResourceDefault

    public static ProcessEngineConfiguration createProcessEngineConfigurationFromResourceDefault()

  - ### createProcessEngineConfigurationFromResource

    public static ProcessEngineConfiguration createProcessEngineConfigurationFromResource(String resource)

  - ### createProcessEngineConfigurationFromResource

    public static ProcessEngineConfiguration createProcessEngineConfigurationFromResource(String resource, String beanName)

  - ### createProcessEngineConfigurationFromInputStream

    public static ProcessEngineConfiguration createProcessEngineConfigurationFromInputStream(InputStream inputStream)

  - ### createProcessEngineConfigurationFromInputStream

    public static ProcessEngineConfiguration createProcessEngineConfigurationFromInputStream(InputStream inputStream, String beanName)

  - ### createStandaloneProcessEngineConfiguration

    public static ProcessEngineConfiguration createStandaloneProcessEngineConfiguration()

  - ### createStandaloneInMemProcessEngineConfiguration

    public static ProcessEngineConfiguration createStandaloneInMemProcessEngineConfiguration()

  - ### getRepositoryService

    public abstract RepositoryService getRepositoryService()

  - ### getRuntimeService

    public abstract RuntimeService getRuntimeService()

  - ### getFormService

    public abstract FormService getFormService()

  - ### getTaskService

    public abstract TaskService getTaskService()

  - ### getHistoryService

    public abstract HistoryService getHistoryService()

  - ### getIdentityService

    public abstract IdentityService getIdentityService()

  - ### getManagementService

    public abstract ManagementService getManagementService()

  - ### getProcessEngineConfiguration

    public abstract ProcessEngineConfiguration getProcessEngineConfiguration()

  - ### getEngineName

    public String getEngineName()
    Specified by:
      `getEngineName` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setEngineName

    public ProcessEngineConfiguration setEngineName(String processEngineName)

  - ### getIdBlockSize

    public int getIdBlockSize()

  - ### setIdBlockSize

    public ProcessEngineConfiguration setIdBlockSize(int idBlockSize)

  - ### getHistory

    public String getHistory()

  - ### setHistory

    public ProcessEngineConfiguration setHistory(String history)

  - ### getDefaultMailClient

    public org.flowable.mail.common.api.client.FlowableMailClient getDefaultMailClient()

  - ### setDefaultMailClient

    public ProcessEngineConfiguration setDefaultMailClient(org.flowable.mail.common.api.client.FlowableMailClient defaultMailClient)

  - ### getDefaultMailServer

    public org.flowable.common.engine.impl.cfg.mail.MailServerInfo getDefaultMailServer()

  - ### setDefaultMailServer

    public ProcessEngineConfiguration setDefaultMailServer(org.flowable.common.engine.impl.cfg.mail.MailServerInfo defaultMailServer)

  - ### getOrCreateDefaultMaiLServer

    protected org.flowable.common.engine.impl.cfg.mail.MailServerInfo getOrCreateDefaultMaiLServer()

  - ### getMailServerHost

    public String getMailServerHost()

  - ### setMailServerHost

    public ProcessEngineConfiguration setMailServerHost(String mailServerHost)

  - ### getMailServerUsername

    public String getMailServerUsername()

  - ### setMailServerUsername

    public ProcessEngineConfiguration setMailServerUsername(String mailServerUsername)

  - ### getMailServerPassword

    public String getMailServerPassword()

  - ### setMailServerPassword

    public ProcessEngineConfiguration setMailServerPassword(String mailServerPassword)

  - ### getMailSessionJndi

    public String getMailSessionJndi()

  - ### setMailSessionJndi

    public ProcessEngineConfiguration setMailSessionJndi(String mailSessionJndi)

  - ### getMailServerPort

    public int getMailServerPort()

  - ### setMailServerPort

    public ProcessEngineConfiguration setMailServerPort(int mailServerPort)

  - ### getMailServerDefaultCharset

    public Charset getMailServerDefaultCharset()

  - ### setMailServerDefaultCharset

    public ProcessEngineConfiguration setMailServerDefaultCharset(Charset mailServerDefaultCharset)

  - ### getMailServerSSLPort

    public int getMailServerSSLPort()

  - ### setMailServerSSLPort

    public ProcessEngineConfiguration setMailServerSSLPort(int mailServerSSLPort)

  - ### getMailServerUseSSL

    public boolean getMailServerUseSSL()

  - ### setMailServerUseSSL

    public ProcessEngineConfiguration setMailServerUseSSL(boolean useSSL)

  - ### getMailServerUseTLS

    public boolean getMailServerUseTLS()

  - ### setMailServerUseTLS

    public ProcessEngineConfiguration setMailServerUseTLS(boolean useTLS)

  - ### getMailServerDefaultFrom

    public String getMailServerDefaultFrom()

  - ### setMailServerDefaultFrom

    public ProcessEngineConfiguration setMailServerDefaultFrom(String mailServerDefaultFrom)

  - ### getMailServerForceTo

    public String getMailServerForceTo()

  - ### setMailServerForceTo

    public ProcessEngineConfiguration setMailServerForceTo(String mailServerForceTo)

  - ### getMailServer

    public org.flowable.common.engine.impl.cfg.mail.MailServerInfo getMailServer(String tenantId)

  - ### getMailServers

    public Map<String,org.flowable.common.engine.impl.cfg.mail.MailServerInfo> getMailServers()

  - ### setMailServers

    public ProcessEngineConfiguration setMailServers(Map<String,org.flowable.common.engine.impl.cfg.mail.MailServerInfo> mailServers)

  - ### getMailClient

    public org.flowable.mail.common.api.client.FlowableMailClient getMailClient(String tenantId)

  - ### getMailClients

    public Map<String,org.flowable.mail.common.api.client.FlowableMailClient> getMailClients()

  - ### setMailClients

    public ProcessEngineConfiguration setMailClients(Map<String,org.flowable.mail.common.api.client.FlowableMailClient> mailClients)

  - ### getMailSessionJndi

    public String getMailSessionJndi(String tenantId)

  - ### getMailSessionsJndi

    public Map<String,String> getMailSessionsJndi()

  - ### setMailSessionsJndi

    public ProcessEngineConfiguration setMailSessionsJndi(Map<String,String> mailSessionsJndi)

  - ### getHttpClientConfig

    public HttpClientConfig getHttpClientConfig()

  - ### setHttpClientConfig

    public void setHttpClientConfig(HttpClientConfig httpClientConfig)

  - ### setDatabaseType

    public ProcessEngineConfiguration setDatabaseType(String databaseType)
    Overrides:
      `setDatabaseType` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setDatabaseSchemaUpdate

    public ProcessEngineConfiguration setDatabaseSchemaUpdate(String databaseSchemaUpdate)
    Overrides:
      `setDatabaseSchemaUpdate` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setDataSource

    public ProcessEngineConfiguration setDataSource(DataSource dataSource)
    Overrides:
      `setDataSource` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcDriver

    public ProcessEngineConfiguration setJdbcDriver(String jdbcDriver)
    Overrides:
      `setJdbcDriver` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcUrl

    public ProcessEngineConfiguration setJdbcUrl(String jdbcUrl)
    Overrides:
      `setJdbcUrl` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcUsername

    public ProcessEngineConfiguration setJdbcUsername(String jdbcUsername)
    Overrides:
      `setJdbcUsername` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcPassword

    public ProcessEngineConfiguration setJdbcPassword(String jdbcPassword)
    Overrides:
      `setJdbcPassword` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setTransactionsExternallyManaged

    public ProcessEngineConfiguration setTransactionsExternallyManaged(boolean transactionsExternallyManaged)
    Overrides:
      `setTransactionsExternallyManaged` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### getHistoryLevel

    public org.flowable.common.engine.impl.history.HistoryLevel getHistoryLevel()

  - ### setHistoryLevel

    public ProcessEngineConfiguration setHistoryLevel(org.flowable.common.engine.impl.history.HistoryLevel historyLevel)

  - ### isEnableProcessDefinitionHistoryLevel

    public boolean isEnableProcessDefinitionHistoryLevel()

  - ### setEnableProcessDefinitionHistoryLevel

    public ProcessEngineConfiguration setEnableProcessDefinitionHistoryLevel(boolean enableProcessDefinitionHistoryLevel)

  - ### setJdbcMaxActiveConnections

    public ProcessEngineConfiguration setJdbcMaxActiveConnections(int jdbcMaxActiveConnections)
    Overrides:
      `setJdbcMaxActiveConnections` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcMaxIdleConnections

    public ProcessEngineConfiguration setJdbcMaxIdleConnections(int jdbcMaxIdleConnections)
    Overrides:
      `setJdbcMaxIdleConnections` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcMaxCheckoutTime

    public ProcessEngineConfiguration setJdbcMaxCheckoutTime(int jdbcMaxCheckoutTime)
    Overrides:
      `setJdbcMaxCheckoutTime` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcMaxWaitTime

    public ProcessEngineConfiguration setJdbcMaxWaitTime(int jdbcMaxWaitTime)
    Overrides:
      `setJdbcMaxWaitTime` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcPingEnabled

    public ProcessEngineConfiguration setJdbcPingEnabled(boolean jdbcPingEnabled)
    Overrides:
      `setJdbcPingEnabled` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcPingQuery

    public ProcessEngineConfiguration setJdbcPingQuery(String jdbcPingQuery)
    Overrides:
      `setJdbcPingQuery` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcPingConnectionNotUsedFor

    public ProcessEngineConfiguration setJdbcPingConnectionNotUsedFor(int jdbcPingNotUsedFor)
    Overrides:
      `setJdbcPingConnectionNotUsedFor` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setJdbcDefaultTransactionIsolationLevel

    public ProcessEngineConfiguration setJdbcDefaultTransactionIsolationLevel(int jdbcDefaultTransactionIsolationLevel)
    Overrides:
      `setJdbcDefaultTransactionIsolationLevel` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### isAsyncExecutorActivate

    public boolean isAsyncExecutorActivate()

  - ### setAsyncExecutorActivate

    public ProcessEngineConfiguration setAsyncExecutorActivate(boolean asyncExecutorActivate)

  - ### isAsyncHistoryExecutorActivate

    public boolean isAsyncHistoryExecutorActivate()

  - ### setAsyncHistoryExecutorActivate

    public ProcessEngineConfiguration setAsyncHistoryExecutorActivate(boolean asyncHistoryExecutorActivate)

  - ### setClassLoader

    public ProcessEngineConfiguration setClassLoader(ClassLoader classLoader)
    Overrides:
      `setClassLoader` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setUseClassForNameClassLoading

    public ProcessEngineConfiguration setUseClassForNameClassLoading(boolean useClassForNameClassLoading)
    Overrides:
      `setUseClassForNameClassLoading` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### getJpaEntityManagerFactory

    public Object getJpaEntityManagerFactory()

  - ### setJpaEntityManagerFactory

    public ProcessEngineConfiguration setJpaEntityManagerFactory(Object jpaEntityManagerFactory)

  - ### isJpaHandleTransaction

    public boolean isJpaHandleTransaction()

  - ### setJpaHandleTransaction

    public ProcessEngineConfiguration setJpaHandleTransaction(boolean jpaHandleTransaction)

  - ### isJpaCloseEntityManager

    public boolean isJpaCloseEntityManager()

  - ### setJpaCloseEntityManager

    public ProcessEngineConfiguration setJpaCloseEntityManager(boolean jpaCloseEntityManager)

  - ### getJpaPersistenceUnitName

    public String getJpaPersistenceUnitName()

  - ### setJpaPersistenceUnitName

    public ProcessEngineConfiguration setJpaPersistenceUnitName(String jpaPersistenceUnitName)

  - ### setDataSourceJndiName

    public ProcessEngineConfiguration setDataSourceJndiName(String dataSourceJndiName)
    Overrides:
      `setDataSourceJndiName` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### getDefaultCamelContext

    public String getDefaultCamelContext()

  - ### setDefaultCamelContext

    public ProcessEngineConfiguration setDefaultCamelContext(String defaultCamelContext)

  - ### isCreateDiagramOnDeploy

    public boolean isCreateDiagramOnDeploy()

  - ### setCreateDiagramOnDeploy

    public ProcessEngineConfiguration setCreateDiagramOnDeploy(boolean createDiagramOnDeploy)

  - ### isDrawSequenceFlowNameWithNoLabelDI

    public boolean isDrawSequenceFlowNameWithNoLabelDI()

  - ### setDrawSequenceFlowNameWithNoLabelDI

    public ProcessEngineConfiguration setDrawSequenceFlowNameWithNoLabelDI(boolean drawSequenceFlowNameWithNoLabelDI)

  - ### getActivityFontName

    public String getActivityFontName()

  - ### setActivityFontName

    public ProcessEngineConfiguration setActivityFontName(String activityFontName)

  - ### getLabelFontName

    public String getLabelFontName()

  - ### setLabelFontName

    public ProcessEngineConfiguration setLabelFontName(String labelFontName)

  - ### getAnnotationFontName

    public String getAnnotationFontName()

  - ### setAnnotationFontName

    public ProcessEngineConfiguration setAnnotationFontName(String annotationFontName)

  - ### setDatabaseTablePrefix

    public ProcessEngineConfiguration setDatabaseTablePrefix(String databaseTablePrefix)
    Overrides:
      `setDatabaseTablePrefix` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setTablePrefixIsSchema

    public ProcessEngineConfiguration setTablePrefixIsSchema(boolean tablePrefixIsSchema)
    Overrides:
      `setTablePrefixIsSchema` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setDatabaseWildcardEscapeCharacter

    public ProcessEngineConfiguration setDatabaseWildcardEscapeCharacter(String databaseWildcardEscapeCharacter)
    Overrides:
      `setDatabaseWildcardEscapeCharacter` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setDatabaseCatalog

    public ProcessEngineConfiguration setDatabaseCatalog(String databaseCatalog)
    Overrides:
      `setDatabaseCatalog` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setDatabaseSchema

    public ProcessEngineConfiguration setDatabaseSchema(String databaseSchema)
    Overrides:
      `setDatabaseSchema` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setXmlEncoding

    public ProcessEngineConfiguration setXmlEncoding(String xmlEncoding)
    Overrides:
      `setXmlEncoding` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### setClock

    public ProcessEngineConfiguration setClock(org.flowable.common.engine.impl.runtime.Clock clock)
    Overrides:
      `setClock` in class `org.flowable.common.engine.impl.AbstractEngineConfiguration`

  - ### getProcessDiagramGenerator

    public org.flowable.image.ProcessDiagramGenerator getProcessDiagramGenerator()

  - ### setProcessDiagramGenerator

    public ProcessEngineConfiguration setProcessDiagramGenerator(org.flowable.image.ProcessDiagramGenerator processDiagramGenerator)

  - ### getAsyncExecutor

    public org.flowable.job.service.impl.asyncexecutor.AsyncExecutor getAsyncExecutor()

  - ### setAsyncExecutor

    public ProcessEngineConfiguration setAsyncExecutor(org.flowable.job.service.impl.asyncexecutor.AsyncExecutor asyncExecutor)

  - ### getAsyncTaskExecutor

    public AsyncTaskExecutor getAsyncTaskExecutor()

  - ### setAsyncTaskExecutor

    public ProcessEngineConfiguration setAsyncTaskExecutor(AsyncTaskExecutor asyncTaskExecutor)

  - ### getAsyncTaskInvokerTaskExecutor

    public AsyncTaskExecutor getAsyncTaskInvokerTaskExecutor()

  - ### setAsyncTaskInvokerTaskExecutor

    public ProcessEngineConfiguration setAsyncTaskInvokerTaskExecutor(AsyncTaskExecutor asyncTaskInvokerTaskExecutor)

  - ### getAsyncTaskInvoker

    public AsyncTaskInvoker getAsyncTaskInvoker()

  - ### setAsyncTaskInvoker

    public ProcessEngineConfiguration setAsyncTaskInvoker(AsyncTaskInvoker asyncTaskInvoker)

  - ### getAsyncHistoryExecutor

    public org.flowable.job.service.impl.asyncexecutor.AsyncExecutor getAsyncHistoryExecutor()

  - ### setAsyncHistoryExecutor

    public ProcessEngineConfiguration setAsyncHistoryExecutor(org.flowable.job.service.impl.asyncexecutor.AsyncExecutor asyncHistoryExecutor)

  - ### getAsyncHistoryTaskExecutor

    public AsyncTaskExecutor getAsyncHistoryTaskExecutor()

  - ### setAsyncHistoryTaskExecutor

    public ProcessEngineConfiguration setAsyncHistoryTaskExecutor(AsyncTaskExecutor asyncHistoryTaskExecutor)

  - ### getDefaultFailedJobWaitTime

    public int getDefaultFailedJobWaitTime()

  - ### setDefaultFailedJobWaitTime

    public ProcessEngineConfiguration setDefaultFailedJobWaitTime(int defaultFailedJobWaitTime)

  - ### getAsyncFailedJobWaitTime

    public int getAsyncFailedJobWaitTime()

  - ### setAsyncFailedJobWaitTime

    public ProcessEngineConfiguration setAsyncFailedJobWaitTime(int asyncFailedJobWaitTime)

  - ### isEnableProcessDefinitionInfoCache

    public boolean isEnableProcessDefinitionInfoCache()

  - ### setEnableProcessDefinitionInfoCache

    public ProcessEngineConfiguration setEnableProcessDefinitionInfoCache(boolean enableProcessDefinitionInfoCache)

  - ### getTaskPostProcessor

    public org.flowable.task.service.TaskPostProcessor getTaskPostProcessor()

  - ### setTaskPostProcessor

    public void setTaskPostProcessor(org.flowable.task.service.TaskPostProcessor processor)

  - ### isEnableHistoryCleaning

    public boolean isEnableHistoryCleaning()

  - ### setEnableHistoryCleaning

    public ProcessEngineConfiguration setEnableHistoryCleaning(boolean enableHistoryCleaning)

  - ### getHistoryCleaningTimeCycleConfig

    public String getHistoryCleaningTimeCycleConfig()

  - ### setHistoryCleaningTimeCycleConfig

    public ProcessEngineConfiguration setHistoryCleaningTimeCycleConfig(String historyCleaningTimeCycleConfig)

  - ### getCleanInstancesEndedAfterNumberOfDays

    @Deprecated public int getCleanInstancesEndedAfterNumberOfDays()
    Deprecated.
    use `getCleanInstancesEndedAfter()` instead

  - ### setCleanInstancesEndedAfterNumberOfDays

    @Deprecated public ProcessEngineConfiguration setCleanInstancesEndedAfterNumberOfDays(int cleanInstancesEndedAfterNumberOfDays)
    Deprecated.
    use `setCleanInstancesEndedAfter(Duration)` instead

  - ### getCleanInstancesEndedAfter

    public Duration getCleanInstancesEndedAfter()

  - ### setCleanInstancesEndedAfter

    public ProcessEngineConfiguration setCleanInstancesEndedAfter(Duration cleanInstancesEndedAfter)

  - ### getCleanInstancesBatchSize

    public int getCleanInstancesBatchSize()

  - ### setCleanInstancesBatchSize

    public ProcessEngineConfiguration setCleanInstancesBatchSize(int cleanInstancesBatchSize)

  - ### getHistoryCleaningManager

    public HistoryCleaningManager getHistoryCleaningManager()

  - ### setHistoryCleaningManager

    public ProcessEngineConfiguration setHistoryCleaningManager(HistoryCleaningManager historyCleaningManager)

  - ### isAlwaysUseArraysForDmnMultiHitPolicies

    public boolean isAlwaysUseArraysForDmnMultiHitPolicies()

  - ### setAlwaysUseArraysForDmnMultiHitPolicies

    public ProcessEngineConfiguration setAlwaysUseArraysForDmnMultiHitPolicies(boolean alwaysUseArraysForDmnMultiHitPolicies)